# Préparation du cours de SRA2 - 2022-23

Pitch : Votre équipe est chargée par un acteur (type entreprise, pouvoir public) de réaliser un état de l'art critique d'un domaine émergent des systèmes répartis.

## Thèmes

> TODO : appuyer l'aspect "réparti" des différents sujets.
> TODO : Attention aux recoupements avec le cours de virtualisation et DevOps.

### **[A] Hyperconverged Infrastructures**

* Declarative modeling 
	
	Configuration par déclaration fonctionnelle type Vagrant, NixOS, Docker, Kube, Nomad...

* Software virtualisation 

	Namespaces Linux, conteneurisation (Docker, LXC, Mesos...)

* Software-defined network/storage/compute

	Distributed operating system

* Service orchestration 

	Synonyme de 'software-defined compute', mettant l'accent sur les outils de provisionnement/service discovery/orchestration (suite Hashicorp, Kube, Docker Swarm, Mesos...)

### **[B] Synchronisation distribuée**

> À développer 

* Consensus 
* Trustless networking

	Blockchains, anonymous authentication, distributed PKI...

* Event-based programming

### **[C] Data persistence** 

> À raffiner
> Attention aux recoupements avec [le cours Bases de Données Avancées (BDA)](https://portail.fil.univ-lille.fr/portail/index.php?dipl=MInfo&sem=GL&ue=BDA&label=Pr%C3%A9sentation) dispensé au début du S3 des GL. [Le cours est ici](https://paperman.name/page/enseignement/2022/nosql/). Le risque est surtout présent avec le [cours 2 : les key-value stores](https://paperman.name/page/enseignement/2022/nosql/cours2.html)

* Block/file/object/stream-storage
* Bakup solutions
* Consistency vs. Availability
* Features: replication, deduplication, snapshotting
* Caracteristics: elasticity, resiliency, latency tolerance

### **[D] Security**

> À raffiner et développer 

* Visualisation and alerting
* Access control
* Disaster recovery
* Adversarial model


## Organisation du module

* 6 semaines (S1 le 7 nov. à S6 le 12 déc.)
* 2 rendus 
	* Dim. 27 nov. 23:59h CET : plan détaillé
	* Dim. 18 déc. 23:59h CET : vidéo de 15-20min


### Déroulement

> En élaboration, se discute.

**S1**

* Attribution aléatoire d'un « thème » à chaque étudiant⋅e (ci-dessous)
* Séance d'état de l'art en grands groupes par thème (« experts »)

	* Utilisation possible d'un outil de glossaire collaboratif ou de mind-mapping (sur PC ou non).

* **Devoirs :** constituer une « équipe » (un binôme) ayant un nom, et proposer un « sujet » (précis et unique - peut être assorti d'un « scenario » ).

	Outil en ligne pour permettre d'atténuer le risque de sujets similaires involontaires ? Pad par « groupe d'experts » ?

**S2**

* Entretiens de 5-10min entre l'encadrant et chaque équipe. 

	Ordre de passage défini aléatoirement. Sujets trop similaires interdits « premier arrivé premier servi » (juste, car aléatoire). Si doublon, on ne valide pas le sujet, l'équipe retourne réfléchir à autre chose et on refait un entretien durant la même séance.

	Un moment pour évaluer le travail de chacun⋅e, et aider à orienter le sujet d'étude et la façon de l'aborder.

**S3**

* **Devoirs :** Plan détaillé à remettre avant le dimanche soir.

**S4**

* Entretiens de 5-10min entre l'encadrant et chaque équipe.

	Un moment pour évaluer le travail de chacun⋅e, et aider à orienter le sujet d'étude et la façon de l'aborder.

**S6**

* **Devoirs :** Vidéo de 15-20min à remettre avant dimanche soir.